VERSION 4.00
Begin VB.Form frmSendKeys 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Using SendKeys with FrontPage 1.1"
   ClientHeight    =   4170
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   6390
   Height          =   4575
   Left            =   1035
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4170
   ScaleWidth      =   6390
   ShowInTaskbar   =   0   'False
   Top             =   1170
   Width           =   6510
   Begin VB.Frame Frame3 
      Caption         =   "FrontPage To Do List"
      Height          =   1335
      Left            =   4320
      TabIndex        =   10
      Top             =   1560
      Width           =   1935
      Begin VB.CommandButton btnAddTask 
         Caption         =   "Assign Task to User"
         Height          =   375
         Left            =   180
         TabIndex        =   12
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton btnDoTask 
         Caption         =   "Do Last Task"
         Height          =   375
         Left            =   180
         TabIndex        =   11
         Top             =   780
         Width           =   1575
      End
   End
   Begin VB.CheckBox chkSync 
      Caption         =   "Use Synchronous SendKeys"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   3060
      Width           =   2655
   End
   Begin VB.Frame Frame2 
      Caption         =   "FrontPage Editor"
      Height          =   1335
      Left            =   2280
      TabIndex        =   8
      Top             =   1560
      Width           =   1935
      Begin VB.CommandButton btnParagraph 
         Caption         =   "Insert Paragraphs"
         Height          =   375
         Left            =   180
         TabIndex        =   4
         Top             =   780
         Width           =   1575
      End
      Begin VB.CommandButton btnNewTable 
         Caption         =   "New Table Page"
         Height          =   375
         Left            =   180
         TabIndex        =   3
         Top             =   360
         Width           =   1575
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "FrontPage Explorer"
      Height          =   1335
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   2055
      Begin VB.CommandButton btnCopyWeb 
         Caption         =   "Begin Copy Web"
         Height          =   375
         Left            =   180
         TabIndex        =   2
         Top             =   780
         Width           =   1695
      End
      Begin VB.CommandButton btnRecalc 
         Caption         =   "Recalculate Links"
         Height          =   375
         Left            =   180
         TabIndex        =   1
         Top             =   360
         Width           =   1695
      End
   End
   Begin VB.Label Label3 
      Caption         =   $"sendkeys.frx":0000
      Height          =   615
      Left            =   120
      TabIndex        =   9
      Top             =   3480
      Width           =   5895
   End
   Begin VB.Label Label2 
      Caption         =   $"sendkeys.frx":00BB
      Height          =   615
      Left            =   120
      TabIndex        =   6
      Top             =   780
      Width           =   6195
   End
   Begin VB.Label Label1 
      Caption         =   $"sendkeys.frx":01B2
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   60
      Width           =   6135
   End
End
Attribute VB_Name = "frmSendKeys"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub btnAddTask_Click()

    Dim hWndToDoList As Long
    Dim FPExplorer As Object
    Dim FPToDoList As Object
    Dim webURL As String
    Dim keys As String
    Dim numtasks As Long
    
    ' use OLE to activate the app or de-iconify it
    Set FPExplorer = CreateObject(FrontPageExplorerID)
    ' see if a web is open
    webURL = FPExplorer.vtiGetWebURL
    Set FPExplorer = Nothing
    
    If Len(webURL) = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "There is no web open in the FrontPage Explorer.", vbExclamation, "SendKeys Example Error"
        Exit Sub
    End If
    
    Set FPToDoList = CreateObject(FrontPageToDoListID)
    FPToDoList.vtiShow
    Set FPToDoList = Nothing
    
    ' look for a window whose title starts with
    ' the characters "FrontPage To Do List"
    hWndToDoList = FindWindow(Me.hWnd, "FrontPage To Do List")
    
    If hWndToDoList = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage To Do List window.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    keys = ""
    ' Page Up to top of list
    keys = keys & "{PGUP}{PGUP}{PGUP}"
    ' Add Task...
    keys = keys & "%A"
    ' Task Name:
    keys = keys & "%T"
    ' (value)
    keys = keys & "Do something"
    ' Assign to:
    keys = keys & "%A"
    ' (value)
    keys = keys & "fred"
    ' Description:
    keys = keys & "%D"
    ' (value)
    keys = keys & "Make yourself useful."
    ' Medium Priority
    keys = keys & "%M"
    ' Return (OK)
    keys = keys & "~"
    
    ' let user see effect of Sync switch
    btnAddTask.Enabled = False
    SafeSendKeys hWndToDoList, keys, (chkSync = 1)
    btnAddTask.Enabled = True

End Sub

Private Sub btnCopyWeb_Click()

    Dim hWndExplorer As Long
    Dim FPExplorer As Object
    Dim webURL As String
    Dim keys As String
    
    ' use OLE to activate the app or de-iconify it
    Set FPExplorer = CreateObject(FrontPageExplorerID)
    ' call BringToTop twice just in case it was iconified
    FPExplorer.vtiBringToTop
    FPExplorer.vtiBringToTop
    ' see if a web is open
    webURL = FPExplorer.vtiGetWebURL
    Set FPExplorer = Nothing
    
    If Len(webURL) = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "There is no web open in the FrontPage Explorer.", vbExclamation, "SendKeys Example Error"
        Exit Sub
    End If
    
    ' look for a window whose title starts with
    ' the characters "FrontPage Explorer"
    hWndExplorer = FindWindow(Me.hWnd, "FrontPage Explorer")
    
    If hWndExplorer = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage Explorer window.", vbExclamation, "SendKeys Example Error"
        Exit Sub
    End If
    
    keys = ""
    ' File->Copy Web
    keys = keys & "%Fp"
    ' Server name:
    keys = keys & "%S"
    ' (value)
    keys = keys & "www.some-company.com"
    ' Web name:
    keys = keys & "%N"
    ' (value)
    keys = keys & "myweb"
    ' Add to existing web
    keys = keys & "%A"
    ' OK
    keys = keys & "~"
    
    ' let user see effect of Sync switch
    btnCopyWeb.Enabled = False
    SafeSendKeys hWndExplorer, keys, (chkSync = 1)
    btnCopyWeb.Enabled = True
 
End Sub


Private Sub btnDoTask_Click()

    Dim hWndToDoList As Long
    Dim FPExplorer As Object
    Dim FPToDoList As Object
    Dim webURL As String
    Dim keys As String
    Dim numtasks As Long
    
    ' use OLE to activate the app or de-iconify it
    Set FPExplorer = CreateObject(FrontPageExplorerID)
    ' see if a web is open
    webURL = FPExplorer.vtiGetWebURL
    Set FPExplorer = Nothing
    
    If Len(webURL) = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "There is no web open in the FrontPage Explorer.", vbExclamation, "SendKeys Example Error"
        Exit Sub
    End If
    
    Set FPToDoList = CreateObject(FrontPageToDoListID)
    numtasks = FPToDoList.vtiGetActiveCount
    If numtasks > 0 Then
        FPToDoList.vtiShow
    End If
    Set FPToDoList = Nothing
    
    ' if no tasks, nothing to do
    If numtasks = 0 Then
       ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "There are no active tasks in the FrontPage To Do List.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    ' look for a window whose title starts with
    ' the characters "FrontPage To Do List"
    hWndToDoList = FindWindow(Me.hWnd, "FrontPage To Do List")
    
    If hWndToDoList = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage To Do List window.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    keys = ""
    ' Page Down to bottom of list
    keys = keys & "{PGDN}{PGDN}{PGDN}"
    ' Do Task
    keys = keys & "%T"
    
    ' let user see effect of Sync switch
    btnDoTask.Enabled = False
    SafeSendKeys hWndToDoList, keys, (chkSync = 1)
    btnDoTask.Enabled = True

End Sub

Private Sub btnNewTable_Click()

    Dim hWndEditor As Long
    Dim FPEditor As Object
    Dim keys As String
    
    ' use OLE to activate the app or de-iconify it
    Set FPEditor = CreateObject(FrontPageEditorID)
    ' call BringToTop once in case it was iconified
    FPEditor.vtiBringToTop
    Set FPEditor = Nothing
        
    ' look for a window whose title starts with
    ' the characters "FrontPage Editor"
    hWndEditor = FindWindow(Me.hWnd, "FrontPage Editor")
    
    If hWndEditor = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage Editor window.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    keys = ""
    ' File->New...
    keys = keys & "%FN"
    ' Return (OK) to choose Normal template
    keys = keys & "~"
    ' Insert->Paragraph->Normal
    keys = keys & "%IPN"
    ' Table->Insert Table
    keys = keys & "%aI"
    ' Rows: 10, Columns: 4, Border Width: 2
    keys = keys & "%R10"
    keys = keys & "%C4"
    keys = keys & "%B2"
    ' Return (OK)
    keys = keys & "~"
    ' enter some text in each column
    keys = keys & "One{RIGHT}Two{RIGHT}Three{RIGHT}Four"
    ' Table->Select Row
    keys = keys & "%aR"
    ' Format->Characters->Bold
    keys = keys & "%oCB"
    ' Return (OK)
    keys = keys & "~"
    ' Page Down
    keys = keys & "{PGDN}"
    
    ' let user see effect of sync switch
    btnNewTable.Enabled = False
    SafeSendKeys hWndEditor, keys, (chkSync = 1)
    btnNewTable.Enabled = True
    
End Sub

Private Sub btnParagraph_Click()

    Dim hWndEditor As Long
    Dim FPEditor As Object
    Dim keys As String
    
    ' use OLE to activate the app or de-iconify it
    Set FPEditor = CreateObject(FrontPageEditorID)
    ' call BringToTop once in case it was iconified
    FPEditor.vtiBringToTop
    Set FPEditor = Nothing
        
    ' look for a window whose title starts with
    ' the characters "FrontPage Editor"
    hWndEditor = FindWindow(Me.hWnd, "FrontPage Editor")
    
    If hWndEditor = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage Editor window.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    keys = ""
    ' File->New...
    keys = keys & "%FN"
    ' Return (OK) to choose Normal template
    keys = keys & "~"
    ' Insert->Paragraph->Normal
    keys = keys & "%IPN"
    ' (type in some text)
    keys = keys & "This is a paragraph sent one character at a time. It may take a while to finish sending.~"
    ' Edit->Paste (3 times)
    Clipboard.SetText "These paragraphs, on the other hand, were sent all at once using the clipboard. This technique is much more efficient for sending anything more than a few characters at a time."
    keys = keys & "%EP~%EP~%EP~"
      
    ' let user see effect of sync switch
    btnParagraph.Enabled = False
    SafeSendKeys hWndEditor, keys, (chkSync = 1)
    btnParagraph.Enabled = True
    
End Sub


Private Sub btnRecalc_Click()
    
    Dim hWndExplorer As Long
    Dim FPExplorer As Object
    Dim webURL As String
    Dim keys As String
    
    ' use OLE to activate the app or de-iconify it
    Set FPExplorer = CreateObject(FrontPageExplorerID)
    ' call BringToTop twice just in case it was iconified
    FPExplorer.vtiBringToTop
    FPExplorer.vtiBringToTop
    ' see if a web is open
    webURL = FPExplorer.vtiGetWebURL
    Set FPExplorer = Nothing
    
    If Len(webURL) = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "There is no web open in the FrontPage Explorer.", vbExclamation, "SendKeys Example Error"
        Exit Sub
    End If
    
    ' look for a window whose title starts with
    ' the characters "FrontPage Explorer"
    hWndExplorer = FindWindow(Me.hWnd, "FrontPage Explorer")
    
    If hWndExplorer = 0 Then
        ' bring us to the top for error messages
        SetForegroundWindow Me.hWnd
        MsgBox "Unable to find FrontPage Explorer window.", vbExclamation, "SendKeys Error"
        Exit Sub
    End If
    
    keys = ""
    ' Tools->Recalculate Links
    keys = keys & "%TR"
    ' OK to proceed? Yes!
    keys = keys & "%Y"
    
    ' let user see effect of Sync switch
    btnRecalc.Enabled = False
    SafeSendKeys hWndExplorer, keys, (chkSync = 1)
    btnRecalc.Enabled = True
    
End Sub


